//
//   This file contains the C++ code from Program 8.1 of
//   "Data Structures and Algorithms
//    with Object-Oriented Design Patterns in C++"
//   by Bruno R. Preiss.
//
//   Copyright (c) 1998 by Bruno R. Preiss, P.Eng.  All rights reserved.
//
//   http://www.pads.uwaterloo.ca/Bruno.Preiss/books/opus4/programs/pgm08_01.cpp
//

#include "Hash.h"
#include "math.h"
#include <string>

HashValue Hash (char c)
    { return abs (c); }

HashValue Hash (int i)
    { return abs (i); }

HashValue Hash (double d)
{
    if (d == 0)
	return 0;
    else
    {
	int exponent;
	double mantissa = frexp (d, &exponent);
	return (2 * fabs (mantissa) - 1) * ~0U;
    }
}

HashValue Hash (std::string const& s)
{
    HashValue result = 0;
    for (unsigned int i = 0; s [i] != 0; ++i)
	result = (result & mask) ^ (result << shift) ^ s [i];
    return result;
}