//
//   This file contains the C++ code from Program 6.2 of
//   "Data Structures and Algorithms
//    with Object-Oriented Design Patterns in C++"
//   by Bruno R. Preiss.
//
//   Copyright (c) 1998 by Bruno R. Preiss, P.Eng.  All rights reserved.
//
//   http://www.pads.uwaterloo.ca/Bruno.Preiss/books/opus4/programs/pgm06_02.cpp
//

#ifndef __STACKASARRAY_H_
#define __STACKASARRAY_H_

#include "classStack.h"
#include "Array.h"
#include "Visitor.h"

#include "header.h"

class StackAsArray : public Stack
{
    Array<Object*> array;

public:
   class Iter : public Iterator
	{
		StackAsArray const& stack;
		unsigned int position;
	public:
		Iter (StackAsArray const&);
    
		void Reset ();

		bool IsDone () const;
		Object& operator * () const;
		void operator ++ ();
	};

public:
    StackAsArray (unsigned int);
	~StackAsArray ();
    
	void Purge ();
	void Accept (Visitor& visitor) const;
	void Push (Object& object);
	Object& Pop ();
	Object& Top () const;

	HashValue Hash () const;
    void Put (std::ostream&) const;

	int CompareTo (Object const&) const { return 0; }

   friend class Iter;
};



#endif  